/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.panel;

import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData.Side;
import com.sencha.gxt.themebuilder.slicer.client.job.AbstractJob;
import com.sencha.gxt.widget.core.client.ContentPanel;
import com.sencha.gxt.widget.core.client.FramedPanel;

/**
 *
 */
public class FramedPanelHeaderJob extends AbstractJob<ContentPanel> {

  @Override
  protected ContentPanel createWidget() {
    FramedPanel panel = new FramedPanel();
    panel.collapse();
    setSize(panel);

    return panel;
  }

  @Override
  public void collectWidgetData(JobCallback callback) {

    //sample
    WidgetData panelData = createWidgetData(getPrefix());

    setRadius(panelData, details.framedPanel().borderRadius());
    setBorders(panelData, widget.getElement());

    setBox(widget, panelData.getBox());

    panelData.getSlices().setCorners(getFolder() + "/" + getPrefix() + ".png");
    panelData.getSlices().setSides(getFolder() + "/" + getPrefix() + ".png");
    panelData.getSlices().setFrame_bg(getFolder() + "/" + getPrefix() + "-background.png");
    panelData.setGradient(WidgetData.GradientDir.top);
    panelData.setStretch(Side.BOTTOM);

    callback.addWidgetData(panelData);
  }

  protected String getFolder() {
    return "panel";
  }
  protected String getPrefix() {
    return "framedpanel-header";
  }
}
