/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.tabs;

import com.google.gwt.core.shared.GWT;
import com.google.gwt.dom.client.Element;
import com.google.gwt.dom.client.NodeList;
import com.google.gwt.user.client.ui.Label;
import com.sencha.gxt.core.client.Style;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData.GradientDir;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData.Side;
import com.sencha.gxt.themebuilder.slicer.client.job.AbstractJob;
import com.sencha.gxt.widget.core.client.TabItemConfig;
import com.sencha.gxt.widget.core.client.TabPanel;
import com.sencha.gxt.widget.core.client.TabPanel.TabPanelAppearance;

public class TabPanelBackgroundJob extends AbstractJob<TabPanel> {
  @Override
  protected TabPanel createWidget() {
    TabPanel tabPanel = new TabPanel(getAppearance());
    tabPanel.setPixelSize(250, 50);
    TabItemConfig tab1Config = new TabItemConfig();
    tab1Config.setHTML("Tab 1");
    tabPanel.add(new Label("Tab 1 content"), tab1Config);
    return tabPanel;
  }

  protected TabPanelAppearance getAppearance() {
    return GWT.create(TabPanelAppearance.class);
  }

  @Override
  public void collectWidgetData(JobCallback callback) {
    //TODO find a better way to get this, simplify tabpanel appearance
    XElement strip = widget.getAppearance().getStripWrap(widget.getElement()).getFirstChildElement().cast();

    NodeList<Element> items = strip.select(widget.getAppearance().getItemSelector());

    WidgetData bgData = createWidgetData("bg");
    XElement tab1 = items.getItem(0).cast();

    bgData.getBox().setH(strip.getHeight(true));
    bgData.getBox().setW(5);
    bgData.getBox().setX(tab1.getX() + tab1.getOffsetWidth() + 5);
    bgData.getBox().setY(getY(strip));

    bgData.getSlices().setBg("tabs/" + imageFileSuffix() + "-strip-bg.png");
    bgData.setGradient(GradientDir.top);
    bgData.setStretch(stretchSide());

    callback.addWidgetData(bgData);
  }

  protected int getY(XElement strip) {
    return strip.getY() + strip.getFrameWidth(Style.Side.TOP);
  }

  protected String imageFileSuffix() {
    return "tab";
  }

  protected Side stretchSide() {
    return Side.BOTTOM;
  }
}
