/**
 * Sencha GXT 4.0.0 - Sencha for GWT
 * Copyright (c) 2006-2015, Sencha Inc.
 *
 * licensing@sencha.com
 * http://www.sencha.com/products/gxt/license/
 *
 * ================================================================================
 * Open Source License
 * ================================================================================
 * This version of Sencha GXT is licensed under the terms of the Open Source GPL v3
 * license. You may use this license only if you are prepared to distribute and
 * share the source code of your application under the GPL v3 license:
 * http://www.gnu.org/licenses/gpl.html
 *
 * If you are NOT prepared to distribute and share the source code of your
 * application under the GPL v3 license, other commercial and oem licenses
 * are available for an alternate download of Sencha GXT.
 *
 * Please see the Sencha GXT Licensing page at:
 * http://www.sencha.com/products/gxt/license/
 *
 * For clarification or additional options, please contact:
 * licensing@sencha.com
 * ================================================================================
 *
 *
 * ================================================================================
 * Disclaimer
 * ================================================================================
 * THIS SOFTWARE IS DISTRIBUTED "AS-IS" WITHOUT ANY WARRANTIES, CONDITIONS AND
 * REPRESENTATIONS WHETHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
 * IMPLIED WARRANTIES AND CONDITIONS OF MERCHANTABILITY, MERCHANTABLE QUALITY,
 * FITNESS FOR A PARTICULAR PURPOSE, DURABILITY, NON-INFRINGEMENT, PERFORMANCE AND
 * THOSE ARISING BY STATUTE OR FROM CUSTOM OR USAGE OF TRADE OR COURSE OF DEALING.
 * ================================================================================
 */
package com.sencha.gxt.themebuilder.slicer.client.job.tabs;

import com.google.gwt.user.client.ui.Label;
import com.sencha.gxt.core.client.dom.XElement;
import com.sencha.gxt.themebuilder.slicer.client.data.WidgetData;
import com.sencha.gxt.widget.core.client.PlainTabPanel;
import com.sencha.gxt.widget.core.client.TabItemConfig;

/**
 *
 */
public class TabPanelScrollerJob extends TabPanelJob {

  @Override
  protected PlainTabPanel createWidget() {
    PlainTabPanel panel = super.createWidget();

    for (int i = 3; i <= 10; i++) {
      panel.add(new Label("Tab " + i + " content"), new TabItemConfig("tab " + i));
    }

    panel.setTabScroll(true);
    // make sure some tab in the middle is selected to get both left and right scrollers active
    panel.setActiveWidget(panel.getWidget(5));

    return panel;
  }

  @Override
  public void collectWidgetData(JobCallback callback) {
    collectWidgetData(callback, "");
  }

  protected void collectWidgetData(JobCallback callback, String suffix) {
    // scrollerLeft
    WidgetData scrollerLeft = createWidgetData("scrollerLeft");
    scrollerLeft.setId("scrollerLeft");
    XElement scrollerLeftElement = getAppearance().getScrollLeft(widget.getElement());
    setBox(scrollerLeftElement, scrollerLeft.getBox());
    scrollerLeft.getSlices().setFull_capture("tabs/scrollerLeft" + suffix + ".png");
    callback.addWidgetData(scrollerLeft);


    // scrollerRight
    WidgetData scrollerRight = createWidgetData("scrollerRight");
    scrollerRight.setId("scrollerRight");
    XElement scrollerRightElement = getAppearance().getScrollRight(widget.getElement());
    setBox(scrollerRightElement, scrollerRight.getBox());
    scrollerRight.getSlices().setFull_capture("tabs/scrollerRight" + suffix + ".png");
    callback.addWidgetData(scrollerRight);
  }
}
